<?php

// 01. URL de l'environnement à appeler (TEST ou PRODUCTION)
$env = substr($_POST['pwdpriv'], 0, 4); 
if ($env == "Live") {
	define('API_ENDPOINT', 'https://secure-gateway.hipay-tpp.com/rest/v1'); // PRODUCTION
}
else define('API_ENDPOINT', 'https://stage-secure-gateway.hipay-tpp.com/rest/v1'); // TEST



// 02. Identifiant API du compte HiPay pour s'authentifier auprès de l'API HiPay
define('API_USERNAME', $_POST['userpriv']);
define('API_PASSWORD', $_POST['pwdpriv']);


	//echo "userpriv : ".$_POST['userpriv']."<br/>";
	//echo "pwdpriv : ".$_POST['pwdpriv']."<br/>";


// 03. Création des 2 variables pour stocker les infos sur l'environnement, l'API et les identifiants API
$resource = API_ENDPOINT . '/order';
$credentials = API_USERNAME . ':' . API_PASSWORD;
if ($_POST['mdp'] == "sdd") {
	$mdp = "sepa-direct-debit";
	$bascule1="";
	$bascule2="";
}
else {
	$mdp = $_POST['mdp'];
}
$amount=rand(100, 199);
//$amount=250;

// 04. Construction de la requête
$request = array(
// 1. Design et paramétrage de la page
'time_to_limit_to_pay' =>'',
'css' =>'',
'language' =>'fr_FR',
'merchant_display_name' =>'',
'orderid'=>'test'.rand(100000000, 999999999),
'authentication_indicator'=>'0',
'display_selector'=>'1',
'payment_product'=>$mdp,


// 2. Paramètrge du paiement
'operation'=> 'Sale',
'eci'=> '7',
'multi_use'=>'1',
'description'=> 'produit test 01',
'long_description'=> 'produit test 01',
'currency'=> 'EUR',
'amount'=>$amount,
'shipping'=> 10,
'tax'=> 10,
'tax_rate'=> 5,


'http_user_agent'=>'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36',
'custom_data' =>
'{
	"shipping_method":"click and collect",
	"first_order":"0",
	"products_list":"First product, Second product, Third product",
	"shipping_description":"Livraison \u00e0 domicile",
	"customer_code":"General",
	"payment_code":"hipay_test",
	"url":"https://test.hipay.com",
	"MT":"120",
	"_reporting_data_1":"my custom data 1"}',

	// 3. Informations du client
	'email'=> 'test.hostedfields@hipay.fr',
	'phone'=> '0123456789',
	'birthdate'=> '19880612',
	'gender'=> 'M',
	'firstname'=> 'Test',
	'lastname'=> 'Hipay',
	'country'=> 'FR',
	'streetaddress'=> '8 Rue de la Paix',
	'streetaddress2'=> '',
	'city'=> 'PARIS',
	'state'=> 'PARIS',
	'zipcode'=> '75002',
	'shipto_firstname'=> 'Test',
	'shipto_lastname'=> 'Hostedfield',
	'shipto_streetaddress'=> '8 Rue de la Paix',
	'shipto_streetaddress2'=> '',
	'shipto_city'=> 'PARIS',
	'shipto_state' => 'PARIS',
	'shipto_zipcode'=> '75002',
	'shipto_country'=> 'FR',
	'shipto_msisdn'=> '+33123456789',
	'cid'=> '123456',
	'ipaddr'=> '',
	'accept_url'=> 'https://developer.hipay.com/simulator/success/',
	'decline_url'=> 'https://developer.hipay.com/simulator/decline/',
	'pending_url'=> 'https://developer.hipay.com/simulator/pending/',
	'exception_url'=> 'https://developer.hipay.com/simulator/exception/',
	'cancel_url'=> 'https://developer.hipay.com/simulator/cancel/',
	//'delivery_method'=> '{\"mode\":\"STORE\",\"shipping\":\"INSTANT\"}'

	); 
	

if ($_POST['mdp'] == "sdd") {
		$request["issuer_bank_id"]=$_POST['bic'];
		$request["iban"]=$_POST['iban'];
}
else {
		$request["cardtoken"]=$_POST['token'];
}
		var_dump($request);
		echo "<br/><strong>API Response: </strong><br/>";


// 05. Initialisation de cURL
$curl = curl_init();

// 07. Définition des en-têtes
$header = array(
  'User-Agent: ' .$_SERVER['HTTP_USER_AGENT'],
  'Accept: application/json',
  'Accept-Language: ' . $_SERVER['HTTP_ACCEPT_LANGUAGE']
);

// 07. Configuration des options de cURL
$options = array(
	CURLOPT_URL => $resource,
	CURLOPT_USERPWD => $credentials,
	CURLOPT_HTTPHEADER => $header,
	CURLOPT_RETURNTRANSFER =>true,
	CURLOPT_FAILONERROR => false,
	CURLOPT_HEADER =>false,
	CURLOPT_POST => true,
	CURLOPT_POSTFIELDS => $request
);


foreach ($options as $option => $value) {
	curl_setopt($curl, $option, $value);
}

// 08. Exécution de cURL
if (false === ($result = curl_exec($curl))) {
	echo "<br/><strong>Error: </strong><br/>";
	var_dump(curl_error($curl), curl_errno($curl));
	exit();
}

$status = (int)curl_getinfo($curl, CURLINFO_HTTP_CODE);

// 09. Affichage de la réponse API
$response = json_decode($result);
$url = $response->state;

var_dump($response);

 // 10. Deconnexion de cURL
curl_close($curl);

// 11. Afficher le bouton "Payer"
if (!empty($response->forwardUrl)) {
	echo "<a href=".$response->forwardUrl.">Payez en cliquant ici !</a><br/>";
}
	echo "State : ".$response->state."<br/>";
	echo "Transaction : ".$response->transactionReference."<br/>";
	echo "Amount : ".$amount."<br/>";
	echo "Status code : ".$response->status."<br/>";
	echo "bic : ".$_POST['bic']."<br/>";
	echo "Message : ".$response->message."<br/>";
?>


