/* global HiPay */

var hipay = HiPay({
  username: '94658453.stage-secure-gateway.hipay-tpp.com',
  password: 'Test_nk7ko6rxLouDf9L5pzN1dSyx',
  environment: 'stage',
  lang: 'fr'
});

// var cardInstance = hipay.create('card', {
//   selector: 'hosted-payments',
//   multi_use: true,
//   fields: {
//     cardHolder: {
//       defaultFirstname: 'John',
//       defaultLastname: 'Doe',
//     }
//   }
// });

var hostedPayments = hipay.create('hosted-payments', {
  selector: 'hosted-payments',
  card: {
    multi_use: true,
    fields: {
      cardHolder: {
        defaultFirstname: 'John',
        defaultLastname: 'Doe'
      }
    }
  }
});

hostedPayments.on('paymentProductChange', function(data) {
  // document.getElementById('hipay-submit-button').disabled = true;
  console.log('paymentProductChange', data);
});
hostedPayments.on('validityChange', function(data) {
  handleError(data.valid, data.error);
  console.log('validityChange', data.valid, data.error);
});

var formElement = document.getElementById('payment-instance-form');

formElement.addEventListener('submit', function(event) {
  event.preventDefault();
  hostedPayments.getPaymentData().then(
    function(response) {
      document.getElementById('hipay-result').classList.add('visible');
      document.getElementById('hipay-result-token').innerHTML = JSON.stringify(
        response,
        null,
        2
      );
      // Pay with API order
    },
    function(error) {
      console.log(error);
      document.getElementById('hipay-result').classList.remove('visible');
      document.getElementById('hipay-result-token').innerHTML = '';

      handleError(false, error);
    }
  );
});

// It display/hide the error message
function handleError(valid, error) {
  document.getElementById('hipay-error-message').innerHTML = error
    ? '<i class="material-icons">cancel</i>' + error
    : error;
  // document.getElementById('hipay-submit-button').disabled = !valid;
}
